<?php
/**
* Flexi Random News - Joomla Module
* Version			: 1.1
* Created by		: Techicore.Com for RumahBelanja.com
* Created on		: v1.0 - November 2010
* Updated			: v1.1 - 12 December 2010
* Package			: Joomla 1.5.x
* Based on			: Flexi Latest News
* License			: http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modFlexiRandomNewsHelper
{
	function getList(&$params)
	{
		global $mainframe;	
		$app =& JFactory::getApplication(); //call JConfig
		$sef 			= $app->getCfg('sef');
		$sef_rewrite 	= $app->getCfg('sef_rewrite');
		
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');
		$permitedtags =  "<i><b><strong><br><a>";
		
		$limittitle = intval( $params->get( 'limittitle', 15 ) );
		$count		= (int) $params->get('count', 5);
		$catid		= trim( $params->get('catid') );
		$secid		= trim( $params->get('secid') );
		$show_front	= $params->get('show_front', 1);
		$aid		= $user->get('aid', 0);
		
		$combination_type	= $params->get( 'combination_type', 1 );
		$time_sys			= $params->get( 'time_sys');
		$name_type 			= $params->get( 'name_type', 1);
		$date_type			= $params->get( 'date_type', 0);
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !$contentConfig->get('show_noauth');
		
		//calculation for Flexi Trendy News
		$cbintegration_plusseo = $sef + $sef_rewrite + $combination_type;

		$nullDate	= $db->getNullDate();

		$date =& JFactory::getDate();
		$now = $date->toMySQL();

		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;

		// User Filter
		switch ($params->get( 'user_id' ))
		{
			case 'by_me':
				$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
				break;
		}

		// Ordering
		$ordering		= 'rand()';
		
		if ($catid)
		{
			$ids = explode( ',', $catid );
			JArrayHelper::toInteger( $ids );
			$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
		}
		if ($secid)
		{
			$ids = explode( ',', $secid );
			JArrayHelper::toInteger( $ids );
			$secCondition = ' AND (s.id=' . implode( ' OR s.id=', $ids ) . ')';
		}

		// Content Items only
		$query = 'SELECT a.*, u.id, u.name, u.username, ' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' FROM #__content AS a' .
			($show_front == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' LEFT JOIN #__users AS u ON u.id = a.created_by' .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE '. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			($catid ? $catCondition : '').
			($secid ? $secCondition : '').
			($show_front == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $ordering;
		$db->setQuery($query, 0, $count);
		$rows = $db->loadObjectList();

		$i		= 0;
		$lists	= array();
		foreach ( $rows as $row )
		{
			if($row->access <= $aid)
			{
				$lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
			} else {
				$lists[$i]->link = JRoute::_('index.php?option=com_user&view=login');
			}
			$lists[$i]->text = htmlspecialchars( $row->title );
				if($limittitle > 0) { //if the limit of title character more than 0
					$lists[$i]->text = flexirandnews_limittext($lists[$i]->text,$permitedtags,$limittitle);
				}
			$lists[$i]->hits = htmlspecialchars( $row->hits );
			$lists[$i]->created_by_alias = htmlspecialchars( $row->created_by_alias );
			$lists[$i]->username = htmlspecialchars( $row->username );
			
			//
			if ($cbintegration_plusseo=="4") { 
				$lists[$i]->created_by = htmlspecialchars( $row->username );
				} else { $lists[$i]->created_by = htmlspecialchars( $row->created_by );
			}
			
			//Created or Modified or Publish Up - Flexi Trendy News
			switch ( $date_type ) {
			case 0;
			default;
				$lists[$i]->created = htmlspecialchars( $row->created );
			break;
			
			case 1;
			$lists[$i]->created = htmlspecialchars( $row->modified );
			break;
			
			case 2;
			$lists[$i]->created = htmlspecialchars( $row->publish_up );
			break;
			}
			
			//username or name alias - Flexi Trendy News
			if ($name_type=="0") { $lists[$i]->name = htmlspecialchars( $row->name ); }
				else {$lists[$i]->name = htmlspecialchars( $row->username );}
			$i++;
		}

		return $lists;
	}
}
//added Limit Function
if (!function_exists("flexirandnews_limittext")) {
function flexirandnews_limittext($text,$permitedtags,$limittitle) {
	$strip = strip_tags($text);
	$endText = (strlen($strip) > $limittitle) ? "..." : ""; 
	$strip = substr($strip, 0, $limittitle);
	$striptag = strip_tags($text, $permitedtags);
	$lentag = strlen($striptag);
	
	$display = "";
	
	$x = 0;
	$ignore = true;
	for($n = 0; $n < $limittitle; $n++) {
		for($m = $x; $m < $lentag; $m++) {
			$x++;
			if($striptag[$m] == "<") {
				$ignore = false;
			} else if($striptag[$m] == ">") {
				$ignore = true;
			}
			if($ignore == true) {
				if($strip[$n] != $striptag[$m]) {
					$display .= $striptag[$m];
				} else {
					$display .= $strip[$n];
					break;
				}
			} else {
				$display .= $striptag[$m];
			}
		}
	}
	return fix_tags ('<span>'.$display.$endText.'</span>');}
}